
;	@com.wudsn.ide.asm.mainsourcefile=GSWBM.asm

	org $3800		;Demo

	opt f+			;Improve packer performance

	.proc demo_benq
	jmp main

;===============================================================

	.proc init

	mwa #0 cnt
	lda #0
	sta $d208
	sta $d218
	lda #3
	sta $d20f
	sta $d21f

	
	rts

	.endp			;End of init

;===============================================================
	.proc vbi
	inw cnt
	ldx #31
	stx $d200
	stx $d210
	inx
	stx $d202
	stx $d212
	lda #0
	sta $d205
	sta $d215
	sta $d207
	sta $d217

	ldx #%00111110
	ldy #0
	lda random
	and #15
	bne skip
	ldy #$05
	lda random
	sta consol
	lda #8
	sta consol
	inx
skip	stx 559 	;set new screen width
	sty $d201
	sty $d203
	sty $d211
	sty $d213
	rts
	.endp			;End of vbi

;===============================================================

	.proc main
	sei			;stop interrups
	lda #0
	sta $d400
	sta nmien
	mva #>pmg pmbase	;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles

////////////////////
// RASTER PROGRAM //
////////////////////

	jsr init
wait_sync
	lda $d40b
	bne wait_sync

LOOP	lda #$ff
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3
	sta sizem
	sta grafm
	mva #$20 hposm0
	mva #$28 hposm1
	mva #$d0 hposm2
	mva #$d8 hposm3

	mva #$02 pmcntl
	lda #$14
	sta gtictl

	lda vcount		;synchronization for the first screen line
	cmp #$02
	bne LOOP

	lda 559
	stx  dmactl	;set new screen width

	mva #<ant dlptr
	mva #>ant dlptr+1

	icl "RC/BenQ/output.png.rp.ini"

;--- wait 18 cycles
	jsr _rts
	inc byt3

;--- set global offset (23 cycles)
	jsr _rts
	cmp byt3\ pha:pla

;--- empty line
	jsr wait54cycle
	inc byt2

  	icl "RC/BenQ/output.png.rp"

raster_program_end

	lda #$0e
	sta $d01a
	sta $d019
	sta $d018
	
//--------------------
//	EXIT
//--------------------


	lda cnt+1
	cmp #10
	beq stop

	lda trig0		; FIRE #0
	and trig1		; FIRE #1
	and consol		; START
	beq stop

	lda skctl		; ANY KEY
	and #$04
	bne skp

stop	mva #$00 pmcntl		;PMG disabled
	tax
clear	sta hposp0,x
	sta $d200,x
	inx
	bne clear
	sta 559
	sta $d400
	lda #3
	sta $d20f
	sta $d21f

	mva #$40 $d40e
	cli
	rts
skp

//--------------------
	jsr vbi
	jmp LOOP

;---

wait54cycle
	:2 inc byt2
wait44cycle
	inc byt3
	nop
wait36cycle
	inc byt3
	jsr _rts
wait18cycle
	inc byt3
_rts	rts

byt3	= $ffff


;---

.MACRO	ANTIC_PROGRAM
	:+8 dta $4e,a(:1+$0000+#*40)
	:+8 dta $4e,a(:1+$0140+#*40)
	:+8 dta $4e,a(:1+$0280+#*40)
	:+8 dta $4e,a(:1+$03C0+#*40)
	:+8 dta $4e,a(:1+$0500+#*40)
	:+8 dta $4e,a(:1+$0640+#*40)
	:+8 dta $4e,a(:1+$0780+#*40)
	:+8 dta $4e,a(:1+$08C0+#*40)
	:+8 dta $4e,a(:1+$0A00+#*40)
	:+8 dta $4e,a(:1+$0B40+#*40)
	:+8 dta $4e,a(:1+$0C80+#*40)
	:+8 dta $4e,a(:1+$0DC0+#*40)
	:+8 dta $4e,a(:1+$0F00+#*40)
	:+8 dta $4e,a(:1+$1040+#*40)
	:+8 dta $4e,a(:1+$1180+#*40)
	:+8 dta $4e,a(:1+$12C0+#*40)
	:+8 dta $4e,a(:1+$1400+#*40)
	:+8 dta $4e,a(:1+$1540+#*40)
	:+8 dta $4e,a(:1+$1680+#*40)
	:+8 dta $4e,a(:1+$17C0+#*40)
	:+8 dta $4e,a(:1+$1900+#*40)
	:+8 dta $4e,a(:1+$1A40+#*40)
	:+8 dta $4e,a(:1+$1B80+#*40)
	:+8 dta $4e,a(:1+$1CC0+#*40)
	:+8 dta $4e,a(:1+$1E00+#*40)
.ENDM

	.endp				;End of main

;===============================================================

	.print *
	org $5c00		;Player missble graphics (players only)
pmg = $5800
	.local pmg2
	icl "RC/BenQ/output.png.pmg"	;With missages commented out manually
	.endl
	m_info pmg2

	org $6010		;Rasterprogram Mode: GED- (bitmap mode)

	.local scr
	ins "RC/BenQ/output.png.mic"
	.endl
	m_info scr

	org $b800		;Display list
	.local ant
	main.ANTIC_PROGRAM scr,ant
	dta $41,a(ant)
	.endl

	m_info ant

	.endp			;End of demo
